Index: serefpolicy-contrib-20140730/radvd.if
===================================================================
--- serefpolicy-contrib-20140730.orig/radvd.if
+++ serefpolicy-contrib-20140730/radvd.if
@@ -1,5 +1,24 @@
 ## <summary>IPv6 router advertisement daemon.</summary>
 
+######################################
+## <summary>
+##	Read radvd PID files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`radvd_read_pid_files',`
+	gen_require(`
+		type radvd_var_run_t;
+	')
+
+	files_search_pids($1)
+	read_files_pattern($1, radvd_var_run_t, radvd_var_run_t)
+')
+
 ########################################
 ## <summary>
 ##	All of the rules required to
@@ -23,8 +42,11 @@ interface(`radvd_admin',`
 		type radvd_var_run_t;
 	')
 
-	allow $1 radvd_t:process { ptrace signal_perms };
+	allow $1 radvd_t:process signal_perms;
 	ps_process_pattern($1, radvd_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 radvd_t:process ptrace;
+	')
 
 	init_labeled_script_domtrans($1, radvd_initrc_exec_t)
 	domain_system_change_exemption($1)
Index: serefpolicy-contrib-20140730/radvd.te
===================================================================
--- serefpolicy-contrib-20140730.orig/radvd.te
+++ serefpolicy-contrib-20140730/radvd.te
@@ -65,8 +65,6 @@ auth_use_nsswitch(radvd_t)
 
 logging_send_syslog_msg(radvd_t)
 
-miscfiles_read_localization(radvd_t)
-
 userdom_dontaudit_use_unpriv_user_fds(radvd_t)
 userdom_dontaudit_search_user_home_dirs(radvd_t)
 
Index: serefpolicy-contrib-20140730/raid.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/raid.fc
+++ serefpolicy-contrib-20140730/raid.fc
@@ -3,6 +3,11 @@
 
 /etc/rc\.d/init\.d/mdmonitor	--	gen_context(system_u:object_r:mdadm_initrc_exec_t,s0)
 
+/etc/mdadm\.conf    --  gen_context(system_u:object_r:mdadm_conf_t,s0)
+
+/usr/lib/systemd/system/mdmon@.* --  gen_context(system_u:object_r:mdadm_unit_file_t,s0)
+/usr/lib/systemd/system/mdmonitor.* --  gen_context(system_u:object_r:mdadm_unit_file_t,s0)
+
 /sbin/iprdump	--	gen_context(system_u:object_r:mdadm_exec_t,s0)
 /sbin/iprinit	--	gen_context(system_u:object_r:mdadm_exec_t,s0)
 /sbin/iprupdate	--	gen_context(system_u:object_r:mdadm_exec_t,s0)
@@ -16,6 +21,7 @@
 /usr/sbin/iprupdate	--	gen_context(system_u:object_r:mdadm_exec_t,s0)
 /usr/sbin/mdadm	--	gen_context(system_u:object_r:mdadm_exec_t,s0)
 /usr/sbin/mdmpd	--	gen_context(system_u:object_r:mdadm_exec_t,s0)
+/usr/sbin/mdmon	--	gen_context(system_u:object_r:mdadm_exec_t,s0)
 /usr/sbin/raid-check	--	gen_context(system_u:object_r:mdadm_exec_t,s0)
 
 /var/run/mdadm(/.*)?	gen_context(system_u:object_r:mdadm_var_run_t,s0)
Index: serefpolicy-contrib-20140730/raid.if
===================================================================
--- serefpolicy-contrib-20140730.orig/raid.if
+++ serefpolicy-contrib-20140730/raid.if
@@ -1,9 +1,8 @@
-## <summary>RAID array management tools.</summary>
+## <summary>RAID array management tools</summary>
 
 ########################################
 ## <summary>
-##	Execute software raid tools in
-##	the mdadm domain.
+##	Execute software raid tools in the mdadm domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -22,34 +21,56 @@ interface(`raid_domtrans_mdadm',`
 
 ######################################
 ## <summary>
-##	Execute mdadm in the mdadm
-##	domain, and allow the specified
-##	role the mdadm domain.
+##	Execute a domain transition to mdadm_t for the
+##	specified role, allowing it to use the mdadm_t
+##	domain
 ## </summary>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	Role allowed to access mdadm_t domain
 ##	</summary>
 ## </param>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed to transition.
+##	Domain allowed to transition to mdadm_t
 ##	</summary>
 ## </param>
 #
 interface(`raid_run_mdadm',`
 	gen_require(`
-		attribute_role mdadm_roles;
+		type mdadm_t;
 	')
 
+	role $1 types mdadm_t;
 	raid_domtrans_mdadm($2)
-	roleattribute $1 mdadm_roles;
+')
+
+######################################
+## <summary>
+##	Execute mdadm server in the mdadm domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`mdadm_systemctl',`
+	gen_require(`
+		type mdadm_t;
+		type mdadm_unit_file_t;
+	')
+
+	systemd_exec_systemctl($1)
+	allow $1 mdadm_unit_file_t:file read_file_perms;
+	allow $1 mdadm_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, mdadm_t)
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	mdadm pid files.
+##	read the mdadm pid files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -57,47 +78,112 @@ interface(`raid_run_mdadm',`
 ##	</summary>
 ## </param>
 #
-interface(`raid_manage_mdadm_pid',`
+interface(`raid_read_mdadm_pid',`
 	gen_require(`
 		type mdadm_var_run_t;
 	')
 
-	files_search_pids($1)
-	allow $1 mdadm_var_run_t:file manage_file_perms;
+	read_files_pattern($1, mdadm_var_run_t, mdadm_var_run_t)
 ')
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an mdadm environment.
+##	Create, read, write, and delete the mdadm pid files.
 ## </summary>
+## <desc>
+##	<p>
+##	Create, read, write, and delete the mdadm pid files.
+##	</p>
+##	<p>
+##	Added for use in the init module.
+##	</p>
+## </desc>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="role">
+#
+interface(`raid_manage_mdadm_pid',`
+	gen_require(`
+		type mdadm_var_run_t;
+	')
+
+	# FIXME: maybe should have a type_transition.  not
+	# clear what this is doing, from the original
+	# mdadm policy
+	allow $1 mdadm_var_run_t:file manage_file_perms;
+')
+
+#######################################
+## <summary>
+##      Check access to the mdadm executable.
+## </summary>
+## <param name="domain">
+##      <summary>
+##      Domain allowed access.
+##      </summary>
+## </param>
+#
+interface(`raid_access_check_mdadm',`
+	gen_require(`
+		type mdadm_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	allow $1 mdadm_exec_t:file { getattr_file_perms execute };
+')
+
+########################################
+## <summary>
+##	Read mdadm config files.
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	Role allowed access.
+##      Domain allowed access.
 ##	</summary>
 ## </param>
-## <rolecap/>
 #
-interface(`raid_admin_mdadm',`
+interface(`raid_read_conf_files',`
 	gen_require(`
-		type mdadm_t, mdadm_initrc_exec_t, mdadm_var_run_t;
+		type mdadm_conf_t;
 	')
 
-	allow $1 mdadm_t:process { ptrace signal_perms };
-	ps_process_pattern($1, mdadm_t)
+    read_files_pattern($1, mdadm_conf_t, mdadm_conf_t)
+')
+
+########################################
+## <summary>
+##	Manage mdadm config files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##      Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`raid_manage_conf_files',`
+	gen_require(`
+		type mdadm_conf_t;
+	')
 
-	init_labeled_script_domtrans($1, mdadm_initrc_exec_t)
-	domain_system_change_exemption($1)
-	role_transition $2 mdadm_initrc_exec_t system_r;
-	allow $2 system_r;
+    manage_files_pattern($1, mdadm_conf_t, mdadm_conf_t)
+')
 
-	files_search_pids($1)
-	admin_pattern($1, mdadm_var_run_t)
+########################################
+## <summary>
+##	Transition to mdadm named content
+## </summary>
+## <param name="domain">
+##	<summary>
+##      Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`raid_filetrans_named_content',`
+	gen_require(`
+		type mdadm_conf_t;
+	')
 
-	raid_run_mdadm($2, $1)
+    files_etc_filetrans($1, mdadm_conf_t, file, "mdadm.conf")
 ')
Index: serefpolicy-contrib-20140730/raid.te
===================================================================
--- serefpolicy-contrib-20140730.orig/raid.te
+++ serefpolicy-contrib-20140730/raid.te
@@ -1,4 +1,4 @@
-policy_module(raid, 1.14.0)
+policy_module(raid, 1.13.1)
 
 ########################################
 #
@@ -15,6 +15,15 @@ role mdadm_roles types mdadm_t;
 type mdadm_initrc_exec_t;
 init_script_file(mdadm_initrc_exec_t)
 
+type mdadm_conf_t;
+files_config_file(mdadm_conf_t)
+
+type mdadm_unit_file_t;
+systemd_unit_file(mdadm_unit_file_t)
+
+type mdadm_tmp_t;
+files_tmpfs_file(mdadm_tmp_t)
+
 type mdadm_var_run_t alias mdadm_map_t;
 files_pid_file(mdadm_var_run_t)
 dev_associate(mdadm_var_run_t)
@@ -25,44 +34,64 @@ dev_associate(mdadm_var_run_t)
 #
 
 allow mdadm_t self:capability { dac_override sys_admin ipc_lock };
-dontaudit mdadm_t self:capability sys_tty_config;
-allow mdadm_t self:process { getsched setsched signal_perms };
+dontaudit mdadm_t self:capability { sys_tty_config sys_ptrace };
+allow mdadm_t self:process { getsched setsched sigchld sigkill sigstop signull signal };
 allow mdadm_t self:fifo_file rw_fifo_file_perms;
 allow mdadm_t self:netlink_kobject_uevent_socket create_socket_perms;
+allow mdadm_t self:unix_stream_socket { create_stream_socket_perms connectto };
+
+manage_files_pattern(mdadm_t, mdadm_conf_t, mdadm_conf_t)
+files_etc_filetrans(mdadm_t, mdadm_conf_t, file, "mdadm.conf")
+
+manage_files_pattern(mdadm_t, mdadm_tmp_t, mdadm_tmp_t)
+manage_dirs_pattern(mdadm_t, mdadm_tmp_t, mdadm_tmp_t)
+files_tmp_filetrans(mdadm_t, mdadm_tmp_t, file)
 
 manage_dirs_pattern(mdadm_t, mdadm_var_run_t, mdadm_var_run_t)
 manage_files_pattern(mdadm_t, mdadm_var_run_t, mdadm_var_run_t)
 manage_lnk_files_pattern(mdadm_t, mdadm_var_run_t, mdadm_var_run_t)
 manage_sock_files_pattern(mdadm_t, mdadm_var_run_t, mdadm_var_run_t)
-dev_filetrans(mdadm_t, mdadm_var_run_t, file)
-files_pid_filetrans(mdadm_t, mdadm_var_run_t, { dir file })
+files_pid_filetrans(mdadm_t, mdadm_var_run_t, { file dir })
+dev_filetrans(mdadm_t, mdadm_var_run_t, { file dir sock_file })
+
+can_exec(mdadm_t, mdadm_exec_t)
 
 kernel_getattr_core_if(mdadm_t)
 kernel_read_system_state(mdadm_t)
 kernel_read_kernel_sysctls(mdadm_t)
 kernel_request_load_module(mdadm_t)
 kernel_rw_software_raid_state(mdadm_t)
+kernel_dontaudit_setsched(mdadm_t)
 
 corecmd_exec_bin(mdadm_t)
 corecmd_exec_shell(mdadm_t)
 
 dev_rw_sysfs(mdadm_t)
-dev_dontaudit_getattr_all_blk_files(mdadm_t)
-dev_dontaudit_getattr_all_chr_files(mdadm_t)
+dev_dontaudit_read_all_blk_files(mdadm_t)
+dev_dontaudit_read_all_chr_files(mdadm_t)
+dev_read_crash(mdadm_t)
+dev_read_framebuffer(mdadm_t)
 dev_read_realtime_clock(mdadm_t)
 dev_read_raw_memory(mdadm_t)
+dev_read_kvm(mdadm_t)
+dev_read_mei(mdadm_t)
+dev_read_nvram(mdadm_t)
+dev_read_generic_files(mdadm_t)
+dev_read_generic_usb_dev(mdadm_t)
+dev_read_urand(mdadm_t)
 
+domain_read_all_domains_state(mdadm_t)
 domain_use_interactive_fds(mdadm_t)
 
-files_read_etc_files(mdadm_t)
 files_read_etc_runtime_files(mdadm_t)
-files_dontaudit_getattr_all_files(mdadm_t)
+files_dontaudit_getattr_tmpfs_files(mdadm_t)
 
 fs_getattr_all_fs(mdadm_t)
 fs_list_auto_mountpoints(mdadm_t)
 fs_list_hugetlbfs(mdadm_t)
 fs_rw_cgroup_files(mdadm_t)
 fs_dontaudit_list_tmpfs(mdadm_t)
+fs_manage_cgroup_files(mdadm_t)
 
 mls_file_read_all_levels(mdadm_t)
 mls_file_write_all_levels(mdadm_t)
@@ -71,15 +100,20 @@ storage_dev_filetrans_fixed_disk(mdadm_t
 storage_manage_fixed_disk(mdadm_t)
 storage_read_scsi_generic(mdadm_t)
 storage_write_scsi_generic(mdadm_t)
+storage_raw_read_removable_device(mdadm_t)
 
 term_dontaudit_list_ptys(mdadm_t)
 term_dontaudit_use_unallocated_ttys(mdadm_t)
 
+auth_use_nsswitch(mdadm_t)
+
 init_dontaudit_getattr_initctl(mdadm_t)
 
+logging_dontaudit_getattr_all_logs(mdadm_t)
 logging_send_syslog_msg(mdadm_t)
 
-miscfiles_read_localization(mdadm_t)
+systemd_exec_systemctl(mdadm_t)
+systemd_start_systemd_services(mdadm_t)
 
 userdom_dontaudit_use_unpriv_user_fds(mdadm_t)
 userdom_dontaudit_search_user_home_content(mdadm_t)
@@ -90,17 +124,38 @@ optional_policy(`
 ')
 
 optional_policy(`
+    dbus_system_bus_client(mdadm_t)
+')
+
+optional_policy(`
 	gpm_dontaudit_getattr_gpmctl(mdadm_t)
 ')
 
 optional_policy(`
+    kdump_manage_kdumpctl_tmp_files(mdadm_t)
+    kdump_rw_lock(mdadm_t)
+')
+
+optional_policy(`
 	mta_send_mail(mdadm_t)
 ')
 
 optional_policy(`
+    mdadm_systemctl(mdadm_t)
+')
+
+optional_policy(`
 	seutil_sigchld_newrole(mdadm_t)
 ')
 
 optional_policy(`
 	udev_read_db(mdadm_t)
 ')
+
+optional_policy(`
+	virt_read_blk_images(mdadm_t)
+')
+
+optional_policy(`
+	xserver_dontaudit_search_log(mdadm_t)
+')
Index: serefpolicy-contrib-20140730/rasdaemon.fc
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/rasdaemon.fc
@@ -0,0 +1,9 @@
+/usr/lib/systemd/system/ras-mc-ctl.*		--	gen_context(system_u:object_r:rasdaemon_unit_file_t,s0)
+
+/usr/lib/systemd/system/rasdaemon.*		--	gen_context(system_u:object_r:rasdaemon_unit_file_t,s0)
+
+/usr/sbin/rasdaemon		--	gen_context(system_u:object_r:rasdaemon_exec_t,s0)
+
+/usr/sbin/ras-mc-ctl		--	gen_context(system_u:object_r:rasdaemon_exec_t,s0)
+
+/var/lib/rasdaemon(/.*)?		gen_context(system_u:object_r:rasdaemon_var_lib_t,s0)
Index: serefpolicy-contrib-20140730/rasdaemon.if
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/rasdaemon.if
@@ -0,0 +1,156 @@
+
+## <summary>The rasdaemon program is a daemon with monitors the RAS trace events from /sys/kernel/debug/tracing</summary>
+
+########################################
+## <summary>
+##	Execute TEMPLATE in the rasdaemon domin.
+## </summary>
+## <param name="domain">
+## <summary>
+##	Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`rasdaemon_domtrans',`
+	gen_require(`
+		type rasdaemon_t, rasdaemon_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, rasdaemon_exec_t, rasdaemon_t)
+')
+
+########################################
+## <summary>
+##	Search rasdaemon lib directories.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`rasdaemon_search_lib',`
+	gen_require(`
+		type rasdaemon_var_lib_t;
+	')
+
+	allow $1 rasdaemon_var_lib_t:dir search_dir_perms;
+	files_search_var_lib($1)
+')
+
+########################################
+## <summary>
+##	Read rasdaemon lib files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`rasdaemon_read_lib_files',`
+	gen_require(`
+		type rasdaemon_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	read_files_pattern($1, rasdaemon_var_lib_t, rasdaemon_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Manage rasdaemon lib files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`rasdaemon_manage_lib_files',`
+	gen_require(`
+		type rasdaemon_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	manage_files_pattern($1, rasdaemon_var_lib_t, rasdaemon_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Manage rasdaemon lib directories.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`rasdaemon_manage_lib_dirs',`
+	gen_require(`
+		type rasdaemon_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	manage_dirs_pattern($1, rasdaemon_var_lib_t, rasdaemon_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Execute rasdaemon server in the rasdaemon domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`rasdaemon_systemctl',`
+	gen_require(`
+		type rasdaemon_t;
+		type rasdaemon_unit_file_t;
+	')
+
+	systemd_exec_systemctl($1)
+        systemd_read_fifo_file_passwd_run($1)
+	allow $1 rasdaemon_unit_file_t:file read_file_perms;
+	allow $1 rasdaemon_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, rasdaemon_t)
+')
+
+
+########################################
+## <summary>
+##	All of the rules required to administrate
+##	an rasdaemon environment
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+## <rolecap/>
+#
+interface(`rasdaemon_admin',`
+	gen_require(`
+		type rasdaemon_t;
+		type rasdaemon_var_lib_t;
+	type rasdaemon_unit_file_t;
+	')
+
+	allow $1 rasdaemon_t:process { ptrace signal_perms };
+	ps_process_pattern($1, rasdaemon_t)
+
+	files_search_var_lib($1)
+	admin_pattern($1, rasdaemon_var_lib_t)
+
+	rasdaemon_systemctl($1)
+	admin_pattern($1, rasdaemon_unit_file_t)
+	allow $1 rasdaemon_unit_file_t:service all_service_perms;
+	optional_policy(`
+		systemd_passwd_agent_exec($1)
+		systemd_read_fifo_file_passwd_run($1)
+	')
+')
Index: serefpolicy-contrib-20140730/rasdaemon.te
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/rasdaemon.te
@@ -0,0 +1,46 @@
+policy_module(rasdaemon, 1.0.0)
+
+########################################
+#
+# Declarations
+#
+
+type rasdaemon_t;
+type rasdaemon_exec_t;
+init_daemon_domain(rasdaemon_t, rasdaemon_exec_t)
+
+type rasdaemon_var_lib_t;
+files_type(rasdaemon_var_lib_t)
+
+type rasdaemon_unit_file_t;
+systemd_unit_file(rasdaemon_unit_file_t)
+
+########################################
+#
+# rasdaemon local policy
+#
+allow rasdaemon_t self:fifo_file rw_fifo_file_perms;
+allow rasdaemon_t self:unix_stream_socket create_stream_socket_perms;
+
+manage_dirs_pattern(rasdaemon_t, rasdaemon_var_lib_t, rasdaemon_var_lib_t)
+manage_files_pattern(rasdaemon_t, rasdaemon_var_lib_t, rasdaemon_var_lib_t)
+files_var_lib_filetrans(rasdaemon_t, rasdaemon_var_lib_t, { dir file  })
+
+kernel_read_system_state(rasdaemon_t)
+kernel_manage_debugfs(rasdaemon_t)
+
+dev_read_raw_memory(rasdaemon_t)
+dev_read_sysfs(rasdaemon_t)
+dev_read_urand(rasdaemon_t)
+dev_rw_cpu_microcode(rasdaemon_t)
+
+modutils_dontaudit_exec_insmod(rasdaemon_t) # more info here #1030277
+
+auth_use_nsswitch(rasdaemon_t)
+
+logging_send_syslog_msg(rasdaemon_t)
+
+optional_policy(`
+    dmidecode_exec(rasdaemon_t)
+')
+
Index: serefpolicy-contrib-20140730/razor.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/razor.fc
+++ serefpolicy-contrib-20140730/razor.fc
@@ -1,9 +1,9 @@
-HOME_DIR/\.razor(/.*)?	gen_context(system_u:object_r:razor_home_t,s0)
+#/root/\.razor(/.*)?		gen_context(system_u:object_r:razor_home_t,s0)
+#HOME_DIR/\.razor(/.*)?		gen_context(system_u:object_r:razor_home_t,s0)
 
-/etc/razor(/.*)?	gen_context(system_u:object_r:razor_etc_t,s0)
+#/etc/razor(/.*)?		gen_context(system_u:object_r:razor_etc_t,s0)
 
-/usr/bin/razor.*	--	gen_context(system_u:object_r:razor_exec_t,s0)
+#/usr/bin/razor.*	--	gen_context(system_u:object_r:razor_exec_t,s0)
 
-/var/lib/razor(/.*)?	gen_context(system_u:object_r:razor_var_lib_t,s0)
-
-/var/log/razor-agent\.log.*	--	gen_context(system_u:object_r:razor_log_t,s0)
+#/var/lib/razor(/.*)?		gen_context(system_u:object_r:razor_var_lib_t,s0)
+#/var/log/razor-agent\.log.*	--	gen_context(system_u:object_r:razor_log_t,s0)
Index: serefpolicy-contrib-20140730/razor.if
===================================================================
--- serefpolicy-contrib-20140730.orig/razor.if
+++ serefpolicy-contrib-20140730/razor.if
@@ -1,72 +1,147 @@
 ## <summary>A distributed, collaborative, spam detection and filtering network.</summary>
+## <desc>
+##	<p>
+##	A distributed, collaborative, spam detection and filtering network.
+##	</p>
+##	<p>
+##	This policy will work with either the ATrpms provided config
+##	file in /etc/razor, or with the default of dumping everything into
+##	$HOME/.razor.
+##	</p>
+## </desc>
 
 #######################################
 ## <summary>
-##	The template to define a razor domain.
+##	Template to create types and rules common to
+##	all razor domains.
 ## </summary>
-## <param name="domain_prefix">
+## <param name="prefix">
 ##	<summary>
-##	Domain prefix to be used.
+##	The prefix of the domain (e.g., user
+##	is the prefix for user_t).
 ##	</summary>
 ## </param>
 #
 template(`razor_common_domain_template',`
 	gen_require(`
-		attribute razor_domain;
-		type razor_exec_t;
+		type razor_exec_t, razor_etc_t, razor_log_t, razor_var_lib_t;
 	')
 
-	########################################
-	#
-	# Declarations
-	#
-
-	type $1_t, razor_domain;
+	type $1_t;
 	domain_type($1_t)
 	domain_entry_file($1_t, razor_exec_t)
 
-	########################################
-	#
-	# Declarations
-	#
+	allow $1_t self:process ~{ ptrace setcurrent setexec setfscreate setrlimit execmem execstack execheap };
+	allow $1_t self:fd use;
+	allow $1_t self:fifo_file rw_fifo_file_perms;
+	allow $1_t self:unix_dgram_socket create_socket_perms;
+	allow $1_t self:unix_stream_socket create_stream_socket_perms;
+	allow $1_t self:unix_dgram_socket sendto;
+	allow $1_t self:unix_stream_socket connectto;
+	allow $1_t self:shm create_shm_perms;
+	allow $1_t self:sem create_sem_perms;
+	allow $1_t self:msgq create_msgq_perms;
+	allow $1_t self:msg { send receive };
+	allow $1_t self:tcp_socket create_socket_perms;
+
+	# Read system config file
+	allow $1_t razor_etc_t:dir list_dir_perms;
+	allow $1_t razor_etc_t:file read_file_perms;
+	allow $1_t razor_etc_t:lnk_file read_lnk_file_perms;
+
+	manage_dirs_pattern($1_t, razor_log_t, razor_log_t)
+	manage_files_pattern($1_t, razor_log_t, razor_log_t)
+	manage_lnk_files_pattern($1_t, razor_log_t, razor_log_t)
+	logging_log_filetrans($1_t, razor_log_t, file)
+
+	manage_dirs_pattern($1_t, razor_var_lib_t, razor_var_lib_t)
+	manage_files_pattern($1_t, razor_var_lib_t, razor_var_lib_t)
+	manage_lnk_files_pattern($1_t, razor_var_lib_t, razor_var_lib_t)
+	files_search_var_lib($1_t)
+
+	# Razor is one executable and several symlinks
+	allow $1_t razor_exec_t:file read_file_perms;
+	allow $1_t razor_exec_t:lnk_file read_lnk_file_perms;
+
+	kernel_read_system_state($1_t)
+	kernel_read_network_state($1_t)
+	kernel_read_software_raid_state($1_t)
+	kernel_getattr_core_if($1_t)
+	kernel_getattr_message_if($1_t)
+	kernel_read_kernel_sysctls($1_t)
+
+	corecmd_exec_bin($1_t)
+
+	corenet_all_recvfrom_unlabeled($1_t)
+	corenet_all_recvfrom_netlabel($1_t)
+	corenet_tcp_sendrecv_generic_if($1_t)
+	corenet_raw_sendrecv_generic_if($1_t)
+	corenet_tcp_sendrecv_generic_node($1_t)
+	corenet_raw_sendrecv_generic_node($1_t)
+	corenet_tcp_sendrecv_razor_port($1_t)
+
+	# mktemp and other randoms
+	dev_read_rand($1_t)
+	dev_read_urand($1_t)
+
+	files_search_pids($1_t)
+	# Allow access to various files in the /etc/directory including mtab
+	# and nsswitch
+	files_read_etc_files($1_t)
+	files_read_etc_runtime_files($1_t)
+
+	fs_search_auto_mountpoints($1_t)
+
+	libs_read_lib_files($1_t)
+
+
+	sysnet_read_config($1_t)
+	sysnet_dns_name_resolve($1_t)
 
-	auth_use_nsswitch($1_t)
+	optional_policy(`
+		nis_use_ypbind($1_t)
+	')
 ')
 
 ########################################
 ## <summary>
-##	Role access for razor.
+##	Role access for razor
 ## </summary>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	Role allowed access
 ##	</summary>
 ## </param>
 ## <param name="domain">
 ##	<summary>
-##	User domain for the role.
+##	User domain for the role
 ##	</summary>
 ## </param>
+## <rolecap/>
 #
 interface(`razor_role',`
 	gen_require(`
-		attribute_role razor_roles;
 		type razor_t, razor_exec_t, razor_home_t;
-		type razor_tmp_t;
 	')
 
-	roleattribute $1 razor_roles;
+	role $1 types razor_t;
 
+	# Transition from the user domain to the derived domain.
 	domtrans_pattern($2, razor_exec_t, razor_t)
 
+	# allow ps to show razor and allow the user to kill it 
 	ps_process_pattern($2, razor_t)
-	allow $2 razor_t:process signal;
-
-	allow $2 { razor_home_t razor_tmp_t }:dir { manage_dir_perms relabel_dir_perms };
-	allow $2 { razor_home_t razor_tmp_t }:file { manage_file_perms relabel_file_perms };
-	allow $2 razor_home_t:lnk_file { manage_lnk_file_perms relabel_lnk_file_perms };
+	allow $2 razor_t:process signal_perms;
+	tunable_policy(`deny_ptrace',`',`
+		allow $2 razor_t:process ptrace;
+	')
 
-	userdom_user_home_dir_filetrans($2, razor_home_t, dir, ".razor")
+	manage_dirs_pattern($2, razor_home_t, razor_home_t)
+	manage_files_pattern($2, razor_home_t, razor_home_t)
+	manage_lnk_files_pattern($2, razor_home_t, razor_home_t)
+	relabel_dirs_pattern($2, razor_home_t, razor_home_t)
+	relabel_files_pattern($2, razor_home_t, razor_home_t)
+	relabel_lnk_files_pattern($2, razor_home_t, razor_home_t)
 ')
 
 ########################################
@@ -81,17 +156,16 @@ interface(`razor_role',`
 #
 interface(`razor_domtrans',`
 	gen_require(`
-		type system_razor_t, razor_exec_t;
+		type razor_t, razor_exec_t;
 	')
 
-	corecmd_search_bin($1)
-	domtrans_pattern($1, razor_exec_t, system_razor_t)
+	domtrans_pattern($1, razor_exec_t, razor_t)
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	razor home content.
+##	Create, read, write, and delete razor files
+##	in a user home subdirectory.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -99,20 +173,19 @@ interface(`razor_domtrans',`
 ##	</summary>
 ## </param>
 #
-interface(`razor_manage_home_content',`
+interface(`razor_manage_user_home_files',`
 	gen_require(`
 		type razor_home_t;
 	')
 
 	userdom_search_user_home_dirs($1)
-	allow $1 razor_home_t:dir manage_dir_perms;
-	allow $1 razor_home_t:file manage_file_perms;
-	allow $1 razor_home_t:lnk_file manage_lnk_file_perms;
+	manage_files_pattern($1, razor_home_t, razor_home_t)
+	read_lnk_files_pattern($1, razor_home_t, razor_home_t)
 ')
 
 ########################################
 ## <summary>
-##	Read razor lib files.
+##	read razor lib files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
